import java.util.concurrent.Semaphore;

class Counter2 {
    int counter = 0;
    final int PEOPLE = 10;
    Semaphore sem = new Semaphore(1);

    public Counter2() {
        try {
            Person[] person = new Person[PEOPLE];
            for (int i = 0; i < PEOPLE; i++) {
                person[i] = new Person();
                person[i].start();
            }

            for (int i = 0; i < PEOPLE; i++) {
                person[i].join();
            }

            System.out.println("counter = " + counter);

        } catch (InterruptedException e) {
            System.out.println(e);
        }

    }

    public static void main(String[] args) {
        new Counter2();
    }

    class Person extends Thread {
        public void run() {
            try {
                boolean enter = false;  // Temporal variable to determine if we enter Liseberg

                while(!enter) { // While not in Liseberg continue trying!

                    if (sem.availablePermits() == 1) { // | Check if there is anyone in the queue
                                                       // | ====== DANGER! DATA RACE! ======
                                                       // | Don't use `availablePermits()` to check whether you should enter the
                                                       // | critical section.
                                                       // | Instead use the method `tryAcquire()` (see Counter3.java)

                        sem.acquire(); // Enter critical section
                        counter++;     // Update share resource
                        System.out.println("People in the queue: "+sem.getQueueLength());
                        sem.release(); // Leave critical section

                        enter = true; // Report that we enter Liseberg

                    } else { // There was someone in the queue
                        // Going for a coffee and come back later
                        // sleep(500);
                    }
                }
            } catch (InterruptedException e) {
                System.out.println(e);
            }
        }
    }
}
